generic
    type Item_Type is private;
package Lists
is
    type List_Type     is limited private;
    type List_Iterator is private;

    function First (List: List_Type) return List_Iterator;
    function Succ (Iterator: List_Iterator) return List_Iterator;
    function Value (Iterator: List_Iterator) return Item_Type;
    function  End_Of_List (Iterator: List_Iterator) return boolean;
    procedure Insert_First (List: List_Type; Item: Item_Type);
    procedure Delete_First (List: List_Type);
private
    type Item_Record;
    type Item_Access is access Item_Record;
    type Item_Record
    is   record
             Item: Item_Type;
             Next: Item_Access;
         end record;
    type List_Header
    is   record
             First: Item_Access;
         end record;
    type List_Access is access all List_Header;
    type List_Type
    is   record
             List: List_Access := new List_Header;
         end record;
    type List_Iterator
    is   record
             List: List_Access;
             Current: Item_Access;
         end record;
end Lists;

      