with Linda; use Linda;
with stringpack; use stringpack;

package body Matrix is

    function "=" (Left, Right: Vector_Parameter_Type) return boolean is
    begin
        return false;
    end "=";

    -- transponiere Matrix A nach Matrix B
    procedure Transpose (A: in Matrix_Type; B: out Matrix_Type) is
    begin
        for  i in 1..3
        loop for  j in 1..3
             loop B (i) (j) := A (j) (i);
             end loop;
        end loop;
    end;

    -- Inneres Produkt zweier Vektoren
    function "*" (Left, Right: Vector_Type) return integer
    is
        Prod: integer := 0;
    begin
        for  i in 1..3
        loop Prod := Prod + Left (i) * Right (i);
        end loop;
        return Prod;
    end "*";

    -- multipliziere zwei Matrizen und gebe das Ergebnis zurueck
    function "*" (Left, Right: Matrix_Type) return Matrix_Type
    is
        B, C: Matrix_Type;
        T   : Tuple_Type;
        It  : Iterator_Type;
        i, j: natural;

        -- Ein Inner_Producer harrt darauf, innere Produkte zu bilden
        task type Inner_Producer;

        -- Hier kann man beliebig viele Produzenten generieren
        Producers: array (1..5) of Inner_Producer;

        task body Inner_Producer
        is
            T: Tuple_Type;
            Element: natural;
            i, j: natural;
            V1, V2: Vector_Type;
        begin
            loop -- Input ("N", Element: integer)
                 Empty (T);
                 Add (T, Char_Parameter_Type'(false, 'N'));
                 Add (T, Int_Parameter_Type'(true, 0));
                 Input (T);
                 Element := Int_Parameter_Type (Value (Succ (First (T)))).Int;
                 -- Output ("N", Element+1)
                 Empty (T);
                 Add (T, Char_Parameter_Type'(false, 'N'));
                 Add (T, Int_Parameter_Type'(false, Element + 1));
                 Output (T);
            exit when Element > 3 * 3;
                 -- Zeile und Spalte ermitteln
                 i := (Element - 1) / 3 + 1;
                 j := (Element - 1) mod 3 + 1;
                 -- Read ("A", i, V1: Vector)
                 Empty (T);
                 Add (T, Char_Parameter_Type'(false, 'A'));
                 Add (T, Int_Parameter_Type'(false, i));
                 Add (T, Vector_Parameter_Type'(true, (others => 0)));
                 Read (T);
                 V1 := Vector_Parameter_Type (Value (Succ (Succ (First (T))))).V;
                 -- Read ("B", j, Vector)
                 Empty (T);
                 Add (T, Char_Parameter_Type'(false, 'B'));
                 Add (T, Int_Parameter_Type'(false, j));
                 Add (T, Vector_Parameter_Type'(true, (others => 0)));
                 Read (T);
                 V2 := Vector_Parameter_Type (Value (Succ (Succ (First (T))))).V;
                 -- Output ("C", i, j, V1 * V2)
                 Empty (T);
                 Add (T, Char_Parameter_Type'(false, 'C'));
                 Add (T, Int_Parameter_Type'(false, i));
                 Add (T, Int_Parameter_Type'(false, j));
                 Add (T, Int_Parameter_Type'(false, V1 * V2));
                 Output (T);
            end loop;
        end Inner_Producer;

    begin
        -- Die zweite Matrix transponieren, um Spaltenvektoren zu erhalten
        Transpose (Right, B);
        -- Die Vektoren der beiden Matrizen ausgeben
        for  i in 1..3
        loop Empty (T);
             Add (T, Char_Parameter_Type'(false, 'A'));
             Add (T, Int_Parameter_Type'(false, i));
             Add (T, Vector_Parameter_Type'(false, Left (i)));
             Output (T);
        end loop;
        for  i in 1..3
        loop Empty (T);
             Add (T, Char_Parameter_Type'(false, 'B'));
             Add (T, Int_Parameter_Type'(false, i));
             Add (T, Vector_Parameter_Type'(false, B (i)));
             Output (T);
        end loop;
        -- Output ("N", 1)
        Empty (T);
        Add (T, Char_Parameter_Type'(false, 'N'));
        Add (T, Int_Parameter_Type'(false, 1));
        Output (T);
        -- Ergebnisse sammeln
        for  k in 1..3*3
        loop -- Input ("C", i: integer, j: integer, c)
             Empty (T);
             Add (T, Char_Parameter_Type'(false, 'C'));
             Add (T, Int_Parameter_Type'(true, 0));
             Add (T, Int_Parameter_Type'(true, 0));
             Add (T, Int_Parameter_Type'(true, 0));
             Input (T);
             It := Succ (First (T));
             i := Int_Parameter_Type (Value (It)).Int;
             It := Succ (It);
             j := Int_Parameter_Type (Value (It)).Int;
             -- C (i) (j) := c
             It := Succ (It);
             C (i) (j) := Int_Parameter_Type (Value (It)).Int;
        end loop;
        return C;
    end "*";

    -- Drucke die Matrix an
    procedure print (M: Matrix_Type)
    is
    begin
        for  i in 1..3
        loop for  j in 1..3
             loop Write (cvis (M (i) (j), 5));
             end loop;
             NewLine;
        end loop;
    end print;

end;