-- Package Tuplespace

-- Tupelraum:     ist eine Liste von Tupeln; diese koennen verschiedenste Typen haben
--

with Tuple; use Tuple;

package Tuplespace is

    type Tuplespace_Type is private;       -- Vordefinition Tupelraum
    type Iterator_Type is private;

    function First (T: Tuplespace_Type) return Iterator_Type;  -- Erstes Tupel
    function Succ (I: Iterator_Type) return Iterator_Type;     -- naechstes Tupel
    function Prev (I: Iterator_Type) return Iterator_Type;     -- vorheriges Tupel
    function Value (I: Iterator_Type) return Tuple_Type;       -- gibt akt. Tupel zurueck
    function  End_Of_Tuplespace (I: Iterator_Type) return boolean;  -- Ende?
    procedure Insert_First (T: Tuplespace_Type; P: Tuple_Type);     -- Tupel einfuegen
    procedure Delete (I: Iterator_Type);                       -- current Tupel loeschen
    function Find_Matching (TS: Tuplespace_Type; T: Tuple_Type) return Iterator_Type;

    No_Tuple_Matches: exception;

private

    type Tuple_Record;
    type Record_Access is access Tuple_Record;
    type Tuple_Access is access all Tuple_Type;

    type Tuple_Record                      -- Tupel-Satz
    is   record                            -- enthaelt
             Prev: Record_Access;          --   Pointer auf vorher.Tupel-Satz
             Tup:  Tuple_Access;           --   Pointer auf Tupel
             Next: Record_Access;          --   Pointer auf naechst.Tupel-Satz
    end record;

    type Tuplespace_Header                  -- Tupelraum-Header
    is   record                            -- enthaelt
             First: Record_Access;         --   Pointer auf 1. Tupel-Satz
    end record;
                                           -- der Pointer auf den Header
    type Tuplespace_Access is access all Tuplespace_Header;

    type Tuplespace_Type                         -- Der Tupelraum (=Liste Tupel-Saetze)
    is   record                            -- erzeugt den Header, der
                                           -- am Anfang auf nix zeigt.
             Header: Tuplespace_Access := new Tuplespace_Header'(First => null);
    end record;

                                           -- Der Iterator verwaltet das:
    type Iterator_Type                          -- Er besteht aus:
    is   record
             Header: Tuplespace_Access;     --   dem Pointer auf den Header
             Current: Record_Access;       --   dem Pointer, der auf den
                                           --   akt. Tupelsatz zeigt
    end record;


end Tuplespace;
